#if !defined( _JJClientObj_h )
#define _JJClientObj_h

#include "JAddObj.h"
#include "JSocket.h"
#include "JSocketInputStream.h"
#include "JSocketOutputStream.h"
#include "JThread.h"
#include "JCriticalSection.h"

#define MaxValues 10

class JJClientObj : public JAddObj {
  protected:
    virtual void writeContent(class JOutputStream& os);
    virtual void readContent(class JDictionary& dict);
  public:
    enum {
      URL, READINPUT, SENDOUTPUT };

    virtual const char* className() const;
    virtual JObject* clone() const;
    JJClientObj();
    JJClientObj(const JJClientObj& obj);
    virtual ~JJClientObj();
    virtual int inputType(int n);
    virtual boolean inputAllowed(int n);
    virtual JString inputTag(int n);
    virtual JFRect inputArea(int n);
    virtual JFRect outputArea(int n);
	virtual int outputType(int n);
    virtual int inputFace(int n);
    virtual JFPoint inputPoint(int n, JLinkObj& link);
    virtual JFPoint outputPoint(int n, JLinkObj& link);
    virtual void paint(JGraphics g, double dx, double dy, JRegion& rgn, double scale);
    virtual void draw(JGraphics g, int x, int y, int w, int h);
    virtual void engine(int n, JLinkObj& link);
    virtual JArray getProperties();
    virtual boolean updateProperty(JProperty& prop);
	    virtual void run();
		virtual void openSocket();
    virtual void access(int n, JLinkObj& link, const JDataType& data);

  protected:
	  void setupResults( char* buf );
	  JThread thread;
	  JSocket socket;
	  int debug;

    // controls
    int readInput;

    // properties
    JString address;
    int port;
	JString url;

	// input
    JString urlargs;  

	// indicates whether last connection was made
	bool madeConnection;

	    // outputs
    int intList[MaxValues];
	double realList[MaxValues];
	JString stringList[MaxValues];

};

#endif
