/*
   MindtelSocket.h

   Simpler sockets for windows.
*/
#ifndef MINDTELSOCKET_H
#define MINDTELSOCKET_H

class MindtelSocket {
public:
	MindtelSocket();
	void Send( const char* buf, int buflen );
	int Recv( char* buf, int buflen );
	void Close();
protected:
	int GetSocket() { return( sockfd ); }
	void SetSocket( int s ) { sockfd = s; }

	int sockfd;

private:
};

class MindtelSocketClient : public MindtelSocket {
public:
	MindtelSocketClient( char* ip, int portNumber );
	bool Connect();
	void GET( char* page );
	int simpleXmlRpc( char* page, char* method, char* params );
	int tidesXmlRpc( char* page, char* method, char* params );
private:
	char ip[30];
	int portNumber;
};

class MindtelSocketServer : public MindtelSocket {
public:
	MindtelSocketServer();
	MindtelSocketServer( int portNumber );
	bool AcceptConnection();
	void SendPage( char* text );
	void Redirect( char* location );
	void GetPage( char* page );
	void Run();
	bool IsRunning() { return( running ); }
	void ShutDown() { running = false; }
	void StartUp() { running = true; }
	void SetIntValue( int i ) { internalValue = i; }
private:
	bool running;
    int listenfd;
	struct sockaddr_in servaddr;
    struct sockaddr_in	cliaddr;

	// for including calculated values in fetched pages
	int internalValue;
};

#endif